//------------------------------------------------|
// C Source File																	|
// Created 10/15/00; 10:51:13 AM									|
//------------------------------------------------|
//All code was done by Sean Kelly, www.skti.org   |
//Feel free to use it, but give me some credit    |
//------------------------------------------------|

#define OPTIMIZE_ROM_CALLS    // Use Speed Optimization
#define SAVE_SCREEN           // Save/Restore LCD Contents
#define USE_GRAY_PATCH				// grayscale graphics
#define USE_INITS_PATCH				// lets you use large integers

#include <tigcclib.h>         // Include All Header Files

int _ti89;                    // Produce .89Z File
unsigned char* plane1=0;      // for grayscale, you need
unsigned char* plane2=0;			// two planes
int viewx=0,maxcol=100,add=20,jT=0,tmpy=0,fall=0,time=0,timer=5000;
int face=0,y=9,x=3,key=0,arrow=0,curEnemy=0,numE=9,what=0,yes=0,lives=4;
int bolts=0,speed=4,check=0,lvl=0,end=0,dead=0,screen=0;

//-------------------------
//sets up the map structure
//-------------------------
typedef struct {
	int type;
} blocktype;

blocktype** map = 0;

//-----------------------
//sets up enemy structure
//-----------------------
blocktype enemy[900] = {
};

#include "graphics8.h"				// all the sprite definitions

//------------------------------------------------------
//sets up the structure that holds the name of the world
//------------------------------------------------------
typedef struct {
	char world[8];
} setString;

setString name[1] = {
	{""}
};

//---------------------------------------------
//draws the level, from viewx to 20 after viewx
//---------------------------------------------
void DrawScreen()
{
	int i,j,k=0,wx,wy;
	for(i=0;i<10;i++)
		{
			for(j=viewx;j<=viewx+20;j++)
				{
					wx=k*8;
					wy=i*8+add;
					masker(wx,wy);
					switch(map[i][j].type)
						{
							case 1:
								bolt(wx,wy); break;
							case 2:
								draw1up(wx,wy); break;
							case 3: 
								lftlndtop(wx,wy); break;
							case 4:
								midlndtop(wx,wy); break;
							case 5:
								rhtlndtop(wx,wy); break;
							case 6:
								qbox(wx,wy); break;
							case 7:
								box(wx,wy); break;
							case 9:
								lftlndmid(wx,wy); break;
							case 10:
								midlndmid(wx,wy); break;
							case 11:
								rhtlndmid(wx,wy); break;
							case 12:
								lftlndbot(wx,wy); break;
							case 13:
								midlndbot(wx,wy); break;
							case 14:
								rhtlndbot(wx,wy); break;
							case 15:
								endPiece(wx,wy); break;
							case 16:
								qbox(wx,wy); break;
						}
					k++;
				}
			k=0;
		}
	DrawLine(0,19,160,19,1);
}

//------------------------
//writes out top stat line
//------------------------
void stats()
{
	draw1up(1,1);
	printf_xy(12,3,"%d",lives);
	bolt(24,1);
	printf_xy(35,3,"%d",bolts);
}

//------------------
//clears both planes
//------------------
void clear()
{
	SetPlane(0);
	ClrScr();
	SetPlane(1);
	ClrScr();
}

//------------------------------
//clears the world name variable
//------------------------------
void InitName()
{
	char s[8]="        ";
	int i;
  for(i=0;i<=8;i++)
	  name[0].world[i]=s[i];
}

//--------------------------
//lets user enter world name
//--------------------------
void ChangeName()
{
	int key=0,curs=0;
	char s[1]=" ";
	InitName();
	clear();
	DrawStr(11,12,"Please Name Your World:",1);
	while(key!=13)
	{
		DrawStr(11,31,name[0].world,A_REPLACE);
		key=ngetchx();
		if(curs<8 && isprint(key))				// makes sure printable char. gives warning
			{
				name[0].world[curs]=key;
				curs++;
			}
		if(key==257 && curs!=0)						// allows for delete key
			{
				name[0].world[curs-1]=s[0];
				curs--;											
			}
	}
	clear();
}

//----------------------------------------------------------------------------
//creates a 2 dimensional array to hold the level data (thanks ti-chess team)!
//----------------------------------------------------------------------------
int SetMapArray() {
    int i;
    if (!(map = (blocktype**)malloc(sizeof(blocktype*)*10))) return 0;
    if (!(map[0] = (blocktype*)malloc(sizeof(blocktype)*maxcol*10))) return 0;
    for (i=1;i<10;i++)
    	map[i] = map[0] + i*maxcol;
    return 1;
}

//-------------------------------------------
//the all important, reads the data from file
//-------------------------------------------
int LoadLevel(int what,int lSt)
{
	int i,j,k;
	FILE* fp;
	if(what) ChangeName();										// if first time, ask for level name
	if(!(fp=fopen(name[0].world,"rb")))				// opens level
		{
			DrawStr(1,1,"File Could Not be Opened",1);
			ngetchx();
			return 0;
		}
	fgetc(fp);																// gets initial number (always)
	for(i=0;i<8;i++)													// skips over level name
		fgetc(fp);															
	for(k=0;k<=lSt/100;k++)										// loads until it finishes current level
		{
			x=fgetc(fp);													// grabs x
			y=fgetc(fp);													// grabs y
			for(i=0;i<10;i++)
				{
					for(j=0;j<maxcol;j++)							// grabs level data
						map[i][j].type=fgetc(fp);
				}
			curEnemy=fgetc(fp);										// grabs number of enemies
			for(i=0;i<numE*curEnemy;i++)					// grabs enemy data
				enemy[i].type=fgetc(fp);
		}
	fclose(fp);																// closes file
	y=(y+1)*8;																// sets y
	x=x*8;																		// sets X
	return 1;
}

//---------------
//yeah, see win()
//---------------
void die()
{
	clear();
	DrawStr(1,1,"You Died",1);
	lives--;
	key=0;
	while(key!=13)
		key=ngetchx();
}

//-------------------------------------
//do I even need to say what this does?
//-------------------------------------
void win()
{
	clear();
	DrawStr(1,1,"You Win",1);
	lvl++;
	key=0;
	while(key!=13)
		key=ngetchx();
}

#include "theEnemy.h"					// all the enemy functions

#include "playerCalls.h"			// all the functions for the player animations

void InitializeVars()
{	
	int i;
	maxcol=100;				// hows many columns in level
	viewx=0;					// which column the screen starts at
	add=20;						// how much to add to Y so at bottom of screen
	tmpy=0;						// counts for how high to jump
	fall=0;						// if falling=1 else =0
	jT=0;							// if jumping=1 else =0
	face=0;						// which direction character is facing (1=left, 0=right)
	timer=5000;				// used to waste time
	key=0;						// used to read keypad
	curEnemy=0;				// how many enemies total, max=30
	numE=10;						// number of attributes each enemy has
	lives=4;					// number of lives
	bolts=0;					// number of bolts
	lvl=0;						// which lvl (current = lvl+1)
	end=0;						// if you beat level = 1, else = 0
	dead=0;						// if you are dead = 1, else =0
	screen=0;					// used to detect whether should show enemies
	for(i=0;i<900;i++)	// stores all 0's into enemy array
		enemy[i].type=0;
}

//--------------------------------------------
//moves the screen over when characer hits end
//--------------------------------------------
void scrollIt()
{
	int i;
	screen++;
	for(i=0;i<=19;i++)
		{
			viewx++;
			DrawScreen();
			x=x-8;
			if(x<0)
				x=0;
			DrawPL();
		}
}

//-----------------------------------------------------
//This is a tough one, it draws the level number!!!!!!!
//-----------------------------------------------------
void LevelScreen()
{
	clear();
	DrawStr(65,42,"Level",1);
	printf_xy(77,50,"%d",lvl+1);
	ngetchx();
	clear();
}

//------------------------------------------------
//the mainloop that handles pretty much everything
//------------------------------------------------
void mainLoop()
{
	void *kbq=kbd_queue( );		// used for key access
	while(lvl<3 && lives>=0)
		{
			LevelScreen();			// displays level number
			DrawScreen();				// draws screen
			DrawNormalRight();	// draws initial character
			FontSetSys(F_4x6);
			while(key!=264 && dead!=1 && end!=1)
				{
					arrow=OSGetStatKeys();	// reads arrow pad
					OSdequeue(&key, kbq);  //reads key pad
					plLoop();							 // all the player animation
					if(x==152 && screen!=4) // if at end of screen
						scrollIt();					 // scroll over
					stats();							 // display status bar at top
					if(y>=80)						   // if hit bottom of screen
						dead=1;							 // die
					if(bolts>=100)
						{
							DrawStr(35,3,"         ",A_REPLACE);
							bolts=0;
							lives++;
						}
				}
			FontSetSys(F_6x8);
			viewx=0;						// moves cursors back to beginning
			screen=0;						// ""			""			""	""		""
			if(dead)						// this is basically self-explanatory
				die();						// if you died, run die() funtion :)
			if(key==264)				// if you press escape,
				lives=-1;					// lives is less than 0 so game stops
			if(end)							// if you hit end of level
				win();						// run the win() function
			dead=0;							// these three
			end=0;							// initialize the variable
			key=0;							// so the loop will keep going
			if(lives>-1 && lvl<3) LoadLevel(0,lvl*100); // loads new level
		}
}

//----------------------
//handles title and menu
//----------------------
int Title()
{
	int ly=35,i;
	if(speed>9)							// sets default speed
		speed=speed/1000;
	ClrScr();
	FontSetSys(F_4x6);
	DrawStr(10,91,"Sean Kelly | Mat Billings | www.skti.org",1);
	FontSetSys(F_8x10);
	DrawStr(24,1,"The Incredible",1);
	DrawStr(43,12,"Adventure",1);
	FontSetSys(F_6x8);
	DrawLine(0,89,160,89,1);
	key=0;
	while(key!=264 && key!=13 && key!=268)
		{	
			DrawStr(20,35,"Play Game!",1);
			DrawStr(20,45,"    Speed:",1);
			DrawStr(20,55,"    Lives:",1);
			DrawStr(20,65,"     Exit!",1);
			printf_xy(100,45,"%d",speed);
			printf_xy(100,55,"%d",lives);
			for(i=ly-1;i<=ly+8;i++)						// draws the lines for cursor
				DrawLine(19,i,80,i,A_XOR);
			key=ngetchx();
			for(i=ly-1;i<=ly+8;i++)						// clear the lines
				DrawLine(19,i,80,i,A_XOR);
			if(key==340 && ly!=65)						// moves lines down
				ly=ly+10;
			if(key==337 && ly!=35)						// moves lines down
				ly=ly-10;
			if(key==344)
				{
					if(ly==45 && speed<=8) speed++;  // if you press right on speed...
					if(ly==55 && lives<=5) lives++;  // if you press right on lives...
				}
			if(key==338)
				{
					if(ly==45 && speed>=2) speed--;  // if you press left of speed...
					if(ly==55 && lives>=5) lives--;  // if you press left of lives...
				}
		}
	if(key!=264)	// if any key other than escape,
		{
			if(ly==65) return 0;		// if you are on exit, leave program
			speed=speed*1000;				// otherwise, set speed
			return 1;								// continue on
		}
	return 0;										// if you press escape, exit program
}

void freeMem()
{
	if(map[0]!=NULL) free(map[0]);
	if(map!=NULL)
		{
			free(map);
			map=NULL;
		}
}

// Main Function
int _main()
{
	SetMapArray();						    // creas 2-D array
	InitializeVars();							// sets initial variable values
	if(Title() && LoadLevel(1,0))
		{
			GrayMode(GRAY_ON);				// turns gray on
			plane1 = GetPlane(0);			// lets you use two planes
		  plane2 = GetPlane(1);			// for grayscale graphics
		  mainLoop();								// start game
		  freeMem();
		  GrayMode(GRAY_OFF);				// turn gray off so calc doesn't crash
		}
	return;												// exit
}
